require 'base.scripts.oop'

class('ClientSide')

ClientSide.clients = {}

-- static class member
-- gets / creates the current client from the net._ptr
function ClientSide:getClient()
	local entID = net._ptr
	local cl = ClientSide.clients[entID]
	if not cl then
		cl = ClientSide:new()
		cl.entID = entID
		ClientSide.clients[entID] = cl
	end
	return cl
end

function ClientSide:ctor()
	-- TODO to make this extensible, maybe provide a class to be called for new's
	-- that must be a subclass of ClientSide ?
	self.updateCallbacks = table.new()
end

function ClientSide:update()
	for _,callback in ipairs(self.updateCallbacks) do
		callback(self)
	end
end


