-- base
-- HUD utility commands

require 'base.scripts.vec'
require 'base.scripts.blend'

nulltex = -1

function vtxForBox(box)
	return {
		box.min[1], box.min[2],
		box.max[1], box.min[2],
		box.max[1], box.max[2],
		box.min[1], box.max[2]
	}
end

function drawRect(args)
	local vtx = vtxForBox(args.box)
	local tc
	if args.tcbox then
		tc = vtxForBox(args.tcbox)
	else
		tc = {0,0,1,0,1,1,0,1}
	end
	drawGeometry(
	--geometry info
		vtx,
		tc,
		args.depth,
	--render info
		args.tex or nulltex,
		args.color,		--vec4f
		0,				--shader
		args.blend or BLEND.NONE,
		args.useAlphaTest,
		args.useBumpMapping,
		args.useLighting,
		args.postFBO,	--post-FBO
	--bumpmap tangent-space adjustment
		1,
		0,
		1);
end

function viewGetBox()
	local b = box2:new()
	local vb = {viewGetBounds()}
	b.min:set(vb[1], vb[2])
	b.max:set(vb[3], vb[4])
	return b
end

function screenFlash(color)
	local camera = viewGetBox()	
	drawRect{box=camera, color=color, depth=-100, blend=BLEND.DECAL}
end