require 'base.scripts.ents'
require 'base.scripts.lighttex'

--used for trigger, light, and waypoint and entity (defined in ents.lua)
animLoad('marker', 'marker.tga')

-- box is a test case . . . implemented in physics and bound in spawn (one of the last of its kind ... )
animLoad('box', 'box.tga')

entclass('Trigger', Collidable)
function Trigger:ctor(table)
	Trigger.super.ctor(self,table)
	self:setUseGravity(false)
	self:setTouchOnly(true)
	self:setAnimGroup('null')
end
Trigger.bbox = box2:new(.45)
Spawnable(Trigger)

entclass('Light', Renderable)
Light.enabled = true
Light.radius = 10
Light.tex = circularLightTex
Light.flicker = false

function Light:ctor(so)
	Light.super.ctor(self,so)
	-- default color.  so's index must match its default tester
	self:setColor{1,1,1,1}
	Light:readSpawnParams(self, so)
end

function Light:toggle() self.enabled = not self.enabled end

-- todo 
-- put this in the render code
-- and make sure all its members are in net tables
-- that
function Light.clientUpdate(classObj)	-- self isn't really self.  its the net object of self.
	Light.super.clientUpdate(classObj)
	if not net.enabled then return end
	local r = net.radius
	if net.flicker then r = r * (.1 * math.sin(3 * getTime()) + .9) end
	
	addLight(net.pos, net.color, net.tex, {min={-r,-r},max={r,r}})
end

SetupSpawnParams(Light, {
	enabled = {'whether the light is on.  default '..tostring(Light.enabled),
		"if so.enabled == 'false' or so.enabled == '0' then self.enabled = false end"};
	radius = 'size of the light',
	color = {'light colol.  default white', 'self:setColor(readVec4(so.color))'};
})

Spawnable(Light)

-- and now for some net tables
Light:createNetTable{
	enabled = 'bool',
	flicker = 'bool',
	radius = 'float',
	tex = 'int',
}

