require 'base.scripts.oop'

-- this uses oop and util
-- which means we'll probably have to overhaul most of it maybe ..

function addVecOps(classobj, dim)
	local classname = classobj.classname	
	
	function buildToNumberStr(var)
		local str = ''
		local sep = ''
		for i=1,dim do
			str = str .. sep .. 'tonumber('..var..'['..i..'])'
			sep = "..','.."
		end
		return str
	end
	
	exec([[
		temp = function(v)
			return ]] .. buildToNumberStr('v') .. [[
		end
	]])
	
	classobj.__tostring = temp
	classobj.tostring = temp

	function vi(index) return index end
	function vb(index) return '[' .. index .. ']' end
	function cv(index) if index == 1 then return '' end return ',' end -- return a comma before every parameter except the first
	
	function buildVecOp(args)
		local str = '\n'		-- space between last token and what we're making.  the \n's will account for the ending space
		for j=1,dim do
			for i,v in ipairs(args) do
				if type(v) == 'function' then
					str = str .. v(j)	-- param index, param string
				else
					str = str .. v
				end
			end
			str = str .. '\n'
		end
		return str
	end

	local ops = {
		add = '+',
		sub = '-',
		mul = '*',
		div = '/',
	}
	-- add binary math ops
	
	function scalarOption(so, prefix, args, suffix)
		local argso = table.new()
		-- for loops completely control iteration.  i'm not sure how to put skips in there.  so i wrote my own loop
		local i = 1
		while i <= #args do
			local v = args[i]
			-- if we find a so vectorindex
			if i < #args and args[i] == so and args[i+1] == vb then
				argso:insert(so)	-- then replace it with so on its own
				i = i + 1
			else
				argso:insert(args[i])
			end
			i = i + 1
		end
		local svo = buildVecOp(args)
		local sso = buildVecOp(argso)
		local str = [[
			if istable(]]..so..[[) then
				]]..prefix..svo..suffix..[[
			else
				]]..so..[[ = castnumber(]]..so..[[)
				]]..prefix..sso..suffix..[[
			end
		]]
		return str
	end
	
	--[[
	op: operate on a and b, store result in v, return v
	opTo: operate an v and a, result in v, return v
	opRet: operate on v and a, result in new, return new
	
	or maybe i should combine them in the lua spirit:
	op(a,b) should operate on a and b, store the result in a new vector, and return it (opRet)
	op(a,b,c) -- or a:op(b,c) should operate on b and c, store the result in a, and result it (op)
	op(a,b) -- or a:op(b) -- i would think would operate on a and b, store the result in a, and return it (opTo)
	-- but the parameter number of opRet and opTo match ...
	--]]
	for k,v in pairs(ops) do
		-- temp is the global exec generates
		-- that makes this not very multithread-safe
		exec([[temp = function(a,b)]]..
scalarOption('b', 'return '..classname..':new(',{cv,'a',vb,v,'b',vb},')')
..[[ end]], classname..'.__'..k)
		classobj['__'..k] = temp
		
		exec([[temp = function(v,a,b)]]..
scalarOption('b', '', {'v',vb,' = a',vb,v,'b',vb}, '')
..[[ return v end]], classname..'.'..k)
		classobj[k] = temp

		local arglist = ''
		local comma = ''
		for i = 1,dim do
			arglist = arglist .. comma .. 'a'..i
			comma = ','
		end
		exec([[temp = function(v, ]]..arglist..[[)
				if a]]..dim..[[ then		-- if the last dim is there then assume its manual parameters.  n.g. for 1d, but we dont use it =)
]]..buildVecOp{'v',vb,' = v',vb,v,'castnumber(a',vi,')'}..[[
				else
]]..scalarOption('a1', '', {'v',vb,' = v',vb,v,'a1',vb}, '')
..[[ 
				end
				return v
			end]], classname..'.'..k..'To')
		classobj[k..'To'] = temp

		exec([[temp = function(v,a) local n = ]]..classname..[[:new() ]]..
scalarOption('a', '', {'n',vb,' = v',vb,v,'a',vb}, '')
..[[ return n end]], classname..'.'..k..'Ret')
		classobj[k..'Ret'] = temp
	end

	-- set
	exec([[
		temp = function(v,...)
			local args = {...}
			if #args == 0 then
]]..buildVecOp{'v', vb, ' = 0'}..[[
			elseif #args == 1 then
				local a = args[1]
				if istable(a) then]]..buildVecOp{'v', vb, ' = a', vb}..[[
				else
					a = castnumber(a)]]..buildVecOp{'v', vb, ' = a'}..[[
				end
			else]]..buildVecOp{'v', vb, ' = castnumber(args', vb ,')'}..[[
			end
			return v
		end
	]])
	classobj.set = temp
	classobj.ctor = temp	-- vec4 default override anyone? to <0,0,0,1> instead of <0,0,0,0>
	classobj.copy = function(v) return classobj:new(v) end

	exec([[
		temp = function(v,from,to,t)
			local it = 1 - t
]]..buildVecOp{'v', vb, ' = from', vb, ' * it + to', vb, ' * t'}..[[
			return v
		end
	]])
	classobj.lerp = temp

	exec([[temp = function(a,b) local d = 0 ]]..buildVecOp{'d = d + a',vb,' * b',vb}..[[ return d end]])
	classobj.dot = temp
	classobj.lenSq = function(v) return classobj.dot(v,v) end				-- L-2 squared
	classobj.len = function(v) return math.sqrt(classobj.lenSq(v)) end		-- L-2 
	classobj.unit = function(v) return classobj.divTo(v, classobj.len(v)) end

	-- same as v:copy():abs():maxElem()
	exec([[
		temp = function(v)
			local l = 0
			]]..buildVecOp{[[
				local av = v]],vb,[[
				if av < 0 then av = -av end		-- get the absolute of this element
				if l < av then l = av end		-- and get the maximum of the absolutes
			]]}..[[
			return l
		end
	]])
	classobj.lenLInf = temp

	exec([[temp = function(a,b) local l local d = 0 ]]..buildVecOp{'l=a',vb,'-b',vb,' d=d+l*l'}..[[ return d end]])
	classobj.distSq = temp
	classobj.dist = function(a,b) return math.sqrt(classobj.distSq(a,b)) end

	-- math bindings
	for i,b in ipairs{'floor', 'abs'} do
		exec([[ temp = function(v) ]] .. buildVecOp{'v',vb,' = math.',b,'(v',vb,')'} .. [[ return v end ]])
		classobj[b] = temp
	end
	
	exec([[ temp = function(v,min,max) ]] .. 
buildVecOp{'if v',vb,' < min then v',vb,' = min elseif v',vb,' > max then v',vb,' = max end'}..
		[[ return v end ]])
	classobj.clamp = temp
	
	-- last make a global for readVecN specific to this class
	-- maybe it should be a class static method?
	exec([[
function readVec]]..dim..[[(s)
	local v = readVecN(s,]]..dim..[[)
	return ]]..classname..[[:new(]]..buildVecOp{cv,'v',vb}..[[)
end]])

	temp = nil
end

-- i dont know why you'd use this bulky class ...
class('vec2')
addVecOps(vec2, 2)

-- TODO - for starters, remove the x,y keys.  then just call table.sort.
function vec2.minElem(v) if v[1] > v[2] then return v[2] else return v[1] end end
function vec2.maxElem(v) if v[1] > v[2] then return v[1] else return v[2] end end
function vec2.minMaxElem(v)
	if v[1] > v[2] then return v[2], v[1] end
	return v[1], v[2]
end
	
-- box operation on the vector
-- transforms v from unit range to the box's coordinate range
function vec2.map(v, b)
	v[1] = b.max[1] * v[1] + b.min[1] * (1 - v[1])
	v[2] = b.max[2] * v[2] + b.min[2] * (1 - v[2])
	return v
end

-- snap to the tile and push to the .5
function vec2:snap()
	self[1] = math.floor(self[1]) + .5
	self[2] = math.floor(self[2]) + .5
	return self
end

function vec2.exp(angle)
	return vec2:new( math.cos(angle), math.sin(angle) )
end

-- converts an angle into a vector (think complex exponential)
-- but does so in degrees
-- vec2 (double)
function vec2.expd(angle)
	return vec2.exp(angle * math.pi / 180)
end

--cplx mul
function vec2.rotv(r,a)
	return vec2:new(
		r[1]*a[1] - r[2]*a[2],
		r[2]*a[1] + r[1]*a[2])
end

class('vec3')
addVecOps(vec3, 3)

class('vec4')
addVecOps(vec4, 4)

class('box2')
function box2:ctor(a,b,c,d)
	if a == nil then
		self.min = vec2:new()
		self.max = vec2:new()
	else
		if istable(a) and a.min and a.max then
			self.min = vec2:new( a.min )
			self.max = vec2:new( a.max )
		elseif b == nil then
			self.min = vec2:new(-a)
			self.max = vec2:new(a)
		elseif c == nil then
			self.min = vec2:new(a)
			self.max = vec2:new(b)
		else
			self.min = vec2:new( castnumber(a), castnumber(b) )
			self.max = vec2:new( castnumber(c), castnumber(d) )
		end
	end
end
	
function box2.copy(b) return box2:new(b) end

function box2.set(dst,a,b,c,d)
	if d ~= nil then
		dst.min[1] = castnumber(a)
		dst.min[2] = castnumber(b)
		dst.max[1] = castnumber(c)
		dst.max[2] = castnumber(d)
	elseif istable(a) then
		if istable(a.min) then	--box
			dst.min[1] = a.min[1]
			dst.min[2] = a.min[2]
			dst.max[1] = a.max[1]
			dst.max[2] = a.max[2]
		else -- vector
			dst.min[1] = -a[1]
			dst.min[2] = -a[2]
			dst.max[1] = a[1]
			dst.max[2] = a[2]
		end
	else	--number
		a = castnumber(a)
		dst.min[1] = -a
		dst.min[2] = -a
		dst.max[1] = a
		dst.max[2] = a
	end
	return dst
end

function box2.divTo(b,v)
	b.min:divTo(v)
	b.max:divTo(v)
	return b
end
	
	-- vec2 size(self)
function box2.size(b)
	return b.max - b.min
end
	
	-- bool touches(box2, box2)
function box2.touches(a,b)
	return	a.min[1] < b.max[1] and
			a.max[1] > b.min[1] and
			a.min[2] < b.max[2] and
			a.max[2] > b.min[2]
end
	
	-- bool contains(box2, vec2)
function box2.contains(a,b)
	return	a.min[1] < b[1] and
			a.max[1] > b[1] and
			a.min[2] < b[2] and
			a.max[2] > b[2]
end
	
function box2.map(a,b) a.min:map(b) a.max:map(b) return a end

do
	box2.addTo = function(src,a,b,c,d)	--accepts box2, vec2, four scalars
		if d ~= nil then
			src.min[1] = src.min[1] + castnumber(a)
			src.min[2] = src.min[2] + castnumber(b)
			src.max[1] = src.max[1] + castnumber(c)
			src.max[2] = src.max[2] + castnumber(d)
		elseif b ~= nil then	-- todo - check for two vec2's
			a = castnumber(a)
			b = castnumber(b)
			src.min[1] = src.min[1] + a
			src.max[1] = src.max[1] + a
			src.min[2] = src.min[2] + b
			src.max[2] = src.max[2] + b
		elseif istable(a) then
			if a.min ~= nil then
				src.min[1] = src.min[1] + castnumber(a.min[1])
				src.min[2] = src.min[2] + castnumber(a.min[2])
				src.max[1] = src.max[1] + castnumber(a.max[1])
				src.max[2] = src.max[2] + castnumber(a.max[2])
			else	-- assume a vector
				local x = castnumber(a[1])
				local y = castnumber(a[2])
				src.min[1] = src.min[1] + x
				src.min[2] = src.min[2] + y
				src.max[1] = src.max[1] + x
				src.max[2] = src.max[2] + y
			end
		else
			a = castnumber(a)
			src.min[1] = src.min[1] + a
			src.min[2] = src.min[2] + a
			src.max[1] = src.max[1] + a
			src.max[2] = src.max[2] + a
		end
		return src
	end
end
	
-- add concat
union(box2, {

	concatPrefix = '[',
	concatSeparator = ',',
	concatSuffix = ']',

	__tostring = function(b)
		return table.concat{box2.concatPrefix, b.min:tostring(), box2.concatSeparator, b.max:tostring(), box2.concatSuffix}
	end,

	__add = function(a,b)
		return box2:new():set(a):addTo(b)
	end,

	__sub = function(a,b)
		return box2:new():set(a):subTo(b)
	end,
})

function readBBox(s)
	local v = readVecN(s,4)
	return box2:new(v[1],v[2],v[3],v[4])
end

