require 'base.scripts.ents'

--[[
you might not expect htis, but this is the default for all our classes
kind of like TakesDamage is for the 'data' mod (move it there maybe?)
--]]

--keep track of all bombable entities.  create/remove them as we go!.  index by _ptr (for ease of use)
bombables = {}  

entclass('Base', Collidable)

-- whether or not we will stop an exposion.  a break block will (change these into map types!) and a bomb will, but a player won't
Base.blocksExplosions = true

-- add/remove from the bombables table upon set/delete

function Base:ctor(...)
	Base.super.ctor(self, ...)
	-- don't call delete in the parent's ctor - or the entry will get set after it is cleared
	bombables[self._ptr] = self	-- keep track of me for fast cycling
	self:setUseGravity(false)	-- no bomberman objects use gravity
	self:setFriction(0)		-- no bomberman objects use friction
end

function Base:delete()
	bombables[self._ptr] = nil
	Base.super.delete(self)
end

