require 'base.scripts.ents'
require 'cs582.scripts.oldladygoods'
require 'cs582.scripts.cutscene'

-- custom objects for the map

animLoad('oldLadyHouse', 'oldladyhouse.png')
entclass('OldLadyHouse',Renderable)
OldLadyHouse.animGroup = 'oldLadyHouse'
OldLadyHouse.zBias = -1.3	-- behind the player
Spawnable(OldLadyHouse)

animLoad('oldLady', {
	sprites = {
		{file='granny/granny.png',bbox={-1,-1.5,1,.5}};
		{file='granny/granny_walk.png',bbox={-1,-1.5,1,.5}};
	};
	seqs = {
		idle = {{joint = 1; time = 0; sprite = 1}};
		walk = {
			{joint = 1; time = 0; sprite = 2};
			{joint = 1; time = .1; sprite = 1};
			{joint = 1; time = .2; sprite = 2};
		};
	};
})
entclass('OldLady', Renderable)	--collidable?
OldLady.animGroup = 'oldLady'
function OldLady:think()
	OldLady.super.think(self)
	if player then
		self:setLeft(player:getPosX() < self:getPosX())
	end
end
Spawnable(OldLady)

function startDialogTouch(self, other)
	if not other or not other:isa(Player) then return end	-- only the player

	-- only need the touch to run once ...
	self:delete()
	
	-- use a number to keep track of how far in the story we are
	if castnumber(persist.story) >= 1 then return end
	
	cutscene(player, function()
		-- recenter on the house
		player.destViewpos:set(house:getPos())

		-- play some dialogs
		player:dialog(	"Yo Ho, good soldier."	)
		player:dialog(	"I see thou hast faired several days wayfaring."	)
		player:dialog(	"But still, alas, I have misfortune I must bequeath you vanquish."	)
		player:dialog(	"See, I lost my puppy.  My one and only dear puppy.  Without it I'll perish pale and fail fade away."	)
		player:dialog(	"Won't you take up my cause, kind hero?"	)
		sleep(1)
		player:dialog(	"I knew you would!  Flippin' sweet."	)
		player:dialog(	"The last place I saw him was down by the river, just over yonder to the west, past this setting sun."	)
		player:dialog(	"Best of luck!")
	end)
end

function ohWaitOnTouch(self, other)
	if not other or not other:isa(Player) then return end
	self:delete()

	-- use a number to keep track of how far in the story we are
	if castnumber(persist.story) >= 1 then return end
	
	cutscene(player, function()
		player.destViewpos:set(house:getPos())	--look back at granny
		
		--looks like we should flip the lady sprite? for std sake.
		-- why dont we give her a think function and make her follow the player?
		
		player:dialog("Oh wait...");
		
		oldLady:setAnimSeq('walk')			-- walk indoors. todo - make a walkTo method?
		for i = 1,20 do
			oldLady:setPosX(oldLady:getPosX() + 0.05)
			sleep(0.05)
		end
		-- TODO: open the door
		oldLady.hidden = true			-- hide the old lady
		oldLady:setAnimSeq('idle')			-- prep her to be seen again
		sleep(1)						-- wait half a second
		oldLady.hidden = false			-- reveal the old lady again
		
		player:dialog("I have some things I need to give to the farmer across the river");
		player:dialog("Could you bring these to him?")
		
		-- enter the lettuce, the goat, and the wolf
		spawnOldLadyGoods(oldLady:getPos(), player)
		
		player:dialog("Thank you very much!")
		
		-- set a session var for our current progress in teh story
		-- read this upon ctor.  if its there then kill these up front
		persist.story = 1
	end)
end

-- im gonna make a generic inter-level door class
-- but how?
-- we would need to link doors to other doors in the scene ...
-- give each door a name and a level
-- match it to the door of that name in the level (via session vars)
-- then we need to, ontouch, save the player's status
-- and then merge this with the player_start, where we load the status ...
function trEndOnTouch(self, other)
	-- here we get to test our load level skillz
	-- execute a 'load level' command
	-- notice this might require us to leave a request at someone elses doorstep
	-- so that it isn't run inside any entity update loops or something like that ...
	loadWorld('level1.world')
end

function onClientSpawn(e)
	player = e		-- keep track anyone

	-- have the guys follow us through
	if castnumber(persist.story) >= 1 and castnumber(persist.story) <= 2 then
		fork(function()
			spawnOldLadyGoods(player:getPos(), player)
		end)
	end
end
