require 'data.scripts.walkenemy'

animLoad('doomguyhead', 'doomguy/doomguyhead.tga')

entclass('DoomGuyHead', TakesDamage, {
	bbox = box2:new(.25);
	animGroup = 'doomguyhead';
	
	ctor = function(self,owner)
		DoomGuyHead.super.ctor(self)
		self:setPos{owner:getPosX(),owner:getPosY()-1.5}
		self:setVelX(4)
		
		if not owner:getLeft() then
			self:setPosX(self:getPosX() + 1)
			self:setVelX(owner:getVelX() + self:getVelX())
		else
			self:setPosX(self:getPosX() - 1)
			self:setVelX(owner:getVelX() - self:getVelX())
		end
		self:setVelY(owner:getVelY() - 5)
		self:setRestitution(.7)
		self:setFriction(.5)
		self:setRotation(90)
		self.endOfTheLine = getTime() + 15
	end;
	
	-- so many peeps use this i should overhaul it
	touch = function(self, other)
		DoomGuyHead.super.touch(self,other)
		self:setRotation(240 * (math.random() - 0.5) * math.sqrt(vec2.lenSq(self:getVel())))
	end,

	onDmg = function(self, other, amount)
		DoomGuyHead.super.onDmg(self, other, amount)
		
		local damageToForce = 1
		local transferMomentum = 0.1
		local dir = vec2:new(self:getPos()) - other:getPos()
		self:setVel(vec2:new(self:getVel()) + dir * (amount * damageToForce * self:getMassInv() / dir:len()))
		
		if other:isa(Collidable) then
			self:setVel(vec2:new(self:getVel()) + vec2:new(other:getVel()) * (transferMomentum * self:getMassInv() / other:getMassInv()))
		end

		if self.health <= 0 then self.health = self.maxHealth end
	end,
	
	think = function(self)
		DoomGuyHead.super.think(self)
		if not self:isActive() then return end	-- needed for any whose parent think() might kill themselves (Collidable)
		
		-- this is only set when the entity is being held.  hijacking flags ...
		if self:getNoPhysics() then
			self.endOfTheLine = getTime() + 60
		end
		
		if getTime() > self.endOfTheLine then
			self:delete()
			return
		end
	end;
})

animLoad('doomguy',{
	sprites = {
		{file='doomguy/doomguy.tga',bbox={-1, -1.5, 1, .5}};
		{file='doomguy/doomguyd0.tga',bbox={-1, -1.5, 1, .5}};
		{file='doomguy/doomguyd1.tga',bbox={-1, -1.5, 1, .5}};
		{file='doomguy/doomguyd2.tga',bbox={-1, -1.5, 1, .5}};
		{file='doomguy/doomguyd3.tga',bbox={-1, -1.5, 1, .5}};
		{file='doomguy/doomguyd4.tga',bbox={-1, -1.5, 1, .5}};
	};
	seqs = {
		idle = {{joint = 1; time = 0; sprite = 1}};
		die = {
			{joint = 1; time = 0; sprite = 2};
			{joint = 1; time = .1; sprite = 3};
			{joint = 1; time = .2; sprite = 4};
			{joint = 1; time = .3; sprite = 5};
			{joint = 1; time = .4; sprite = 6};
			{joint = 1; time = .5; sprite = 6};
		};
	};
})

entclass('DoomGuy', WalkEnemy, {
	animGroup = 'doomguy';
	bbox = box2:new(-.45,-1.45,.45,.45);
	maxHealth = 10,	--TakesDamage

	death = function(self, other, damage)
		DoomGuyHead:new(self)
		-- how many times is a death routine called anyways?
		DoomGuy.super.death(self,other,damage)
	end,
})
Spawnable(DoomGuy)
