effects = {
	{name='Dark'; };
	--[[
		function render() drawSprite(sunglasses) end
		function applyStats(stats) stats.hitChance = stats.hitChance * .5 end
	--]]
	
	{name='Zombie'; };
	--[[
		function getPalette() return zombiePallete end
		function applyStats(stast) stats.hp = 0 end
		function isSkillEnabled(x) return false end
		function isCountedForVictory() return false end
		function onTurn()
			attack any char in the battle at random
			...with 1/16 chance of casting Dark on the target
			...and 1/16 chance of casting Poison on the target
		end
	--]]
	
	{name='Poison'; };
	--[[
		function getPalette() return poisonPalette end
		function getTimerFrequency() return 17 end
		function onTimer(char, state)
			state.tick = math.max((state.tick or 0) + 1, 4)
			char:dealDamage( 2^state.tick * poisonDamage)
		end
		function onStep(client)
			for _,charIndex in ipairs(client.chars) do
				local char = chars[charIndex]
				char:dealDamage( math.min(char.maxHP / 32, char.hp - 1) )
			end
		end
	--]]
	
	{name='Clear'; };
	--[[
		function getPalette() return clearPalette end
		function applyStats(stats)
			stats.magicEvade = 0
			stats.battleEvade = stats.MAX
		end
	--]]
	
	{name='Imp'; };
	--[[
		function getAnimGroup() return 'imp' end
		function isSkillEnabled(x)
			if x == skillsIndexForName.Fight
			or x == skillsIndexForName.Magic
			or x == skillsIndexForName.Item
			then return true
			end
			return false
		end
		function isMagicEnabled(x)
			if x == magicIndexForName.Imp then return true end
			return false
		end
		function applyStats(stats, char)
			if not char:getWeaponsEquipped():find('Imp Halbred', function(v, name) return v.name == name) then
				stats.battlePower = 1
			end
		end
	--]]
	
	{name='Petrify'; };
	--[[
		function getPalette() return petrifyPalette end
		function applyStats(stats)
			stats.hp = 0
			stats.battleEvade = 0
		end
		function onTurn() pass end
		function getBattleGaugeSpeed() return 0 end
		function isConsideredForVictory() return false end
		function damageCalcLastModifer(x) return 0 end
	--]]
	
	{name='Wound'; };
	--[[
		function getAnimSeq() return 'wound' end
		function isConsideredForVictory() return false end
		function getBattleGaugeSpeed() return 0 end
	--]]
	
	{name='Condemned'; };
	--[[
		function getTimerFrequency() return 2 end
		function onTimerInit(attacker, state)
			state.tick = math.max(79 - math.random(attacker.level, 2 * attacker.level - 1), 20)
		end
		function onTimer(state)
			state.tick = state.tick - 1
			if state.tick <= 0 then
				target:kill()
				remove this attribute
			end
		end
		function render(state)
			drawText(state.tick)
		end
	--]]
	
	{name='Near Fatal'; };
	--[[
		-- should near fatal be responsible for checking if it goes away or not?  sure...
		-- or shoud this be built-in (with Wound too?)
	function onStatSet(statField, value)
		if statField == 'hp' then
			if value > char.maxHP / 8 then
				remove this attribute
			end
		end
	end
	--]]
	
	{name='Image'; };
	--[[
		function applyStats(stats)
			stats.battleEvade = MAX
		end
	--]]
	
	{name='Mute'; };
	--[[
		function render() draw(speechBubble) end
		function isSkillEnabled(x)
			if x == skillsIndexForName.Magic then return false end
			return true
		end
	--]]
	
	{name='Berzerk'; };
	--[[
	function getPalette() return berzerkPalette() end
	function applyStats(stats)
		stats.battlePower = stats.battlePower * 1.5
	end
	function onTurn()
		pick a random skill (fight, capture, jump, rage, magitech)
		target a random opponent
		attack
	end
	--]]
	
	{name='Muddle'; };
	--[[
	function getAnimSeq()
		spin around
	end
	function onTurn()
		choose any random ability except those that use items, those that steal, those that control
	end
	function onReceiveDamage()
		remove this stat
	end
	--]]

--[[
	13	seizure
			passive battle callback, every 8.5 seconds:
				deal damage to the character
	14	sleep
			what is your battle gauge speed?	0
			what to do on your turn?			pass
			passive battle callback, 30 seconds: remove sleep
			what to do when you take damage?	remove sleep
			what is your physical evade?		none
			what is your magic evade?			none
	15	dance
			what to do on your turn?			a random dance
	16	regen
			passive battle callback, every 8.5 seconds:
				heal character by min((Max HP * stamina / 1024) + 2, 255) * ([224..255]) / 256
	17	slow
			what is your battle gauge speed?	half
	18	haste
			what is your battle gauge speed?	double
	19	stop
			what is your battle gauge speed?	0
			what to do on your turn?			pass
			passive battle callback, 38 seconds: remove stop
	20	shell
			what to do when you take magic damage?		reduce by 170/256 (unless the attack is defense-ignoring)
	21	safe
			what to do when you take physical damage?	reduce by 170/256 (unless the attack is defense-ignoring)
	22	reflect
			what to do when a spell targets you?	have it target a random opponent and reduce its damage by 50%
	23	charm bangle
			what is our random battle rate?		half
	24	moogle charm
			what is our random battle rate?		none
	25	sprint shoes
			what is our walking speed?			double
	26	tintinabar
			after a step is taken?
				heal character by stamina / 4
	27	atlas armlet
			what to do when you deal physical damage?	increase by 5/4
	28	earrings
			what to do when you deal magic damage?		increase by 5/4
		red cap - ups hp by 25%
		muscle belt - ups hp by 50%
		green beret - ups hp a little -- and keeps it on level up
		minerva - ups mag def?
		crystal orb - ups mp by 50%
		bards hat - ups mp a little -- and keeps it on level up
		gale hairpin - raises pre-emptive attack rate
		dragoon boots -  changes 'fight' to 'jump'
		gem box -        changes 'magic' to 'x magic'
		fake mustache -  changes 'sketch' to 'control'
		coin toss -      changes 'slot' to 'gp rain'
		thief glove -    changes 'steal' to 'capture'
		dragon horn -    makes jump x4
		sneak ring -     raises sucess rate of 'steal'
		beret -          raises sucess rate of 'sketch'
		coronet -        raises sucess rate of 'control'
		sniper sight -   100% hit rate
		gold hairpin -   halves MP consumed
		economizer -     spells only cost 1
		Hyper Wrist -    ups vigor by 50%
		"offering -       makes attack x4";
		"black belt -     randomally counterattacks";
		"beads -          randomally evades an enemy's attacks";
		"gauntlet -       one weapon can be held w/2 hands";
		"genji glove -    two weapons can be held at once";
		"merit award -    allows heavy armor to be equipped";
		"true knight -    protects party members who are low on HP";
		"barrier ring -   casts 'shell' when HP is low";
		"mithril glove -  casts 'safe' when HP is low";
		"exp. egg -       doubles experience gained";
		"cat hood -       picks up all possible GP";
		"relic ring -     makes body cold";
		"protection from mortal blows";
		"runic";
		"same damage from back row";
		"2 hands";
		"swdtech";
		"randomally steals";
		"transforms at level up, grows as HP increases";
		"randomally dispatches an enemy";
		"double damage to humans";
		"absorbs damage as HP";
		"absorbs damage as MP";
		"uses MP for mortal blow";
		"whatever a hawk eye does ???";
		"dice - what dice do";
		"gains power as HP decreases";
		"randomally casts 'wind slash'";
		"heals person";
		"randomally dices up an enemy";
		"uses MP for mortal blow, may break";
		"uses MP for mortal blow";
--]]	
}