require 'wellstory.scripts.ents'

animLoad('breakblock.png')

entclass('BreakBlock', TakesDamage)
BreakBlock.animGroup = 'breakblock.png'
BreakBlock.bbox = box2:new(.49)
BreakBlock.massInv = 1/2
Spawnable(BreakBlock)

function BreakBlock:onDmg(...)
	BreakBlock.super.onDmg(self, ...)
	for i=0,1 do
		for j=0,1 do
			local bb = SmallBreakBlock:new{
				pos={
					self:getPosX() - .25 + i * .5,
					self:getPosY() - .25 + j * .5,
				};
				vel=self:getVel();
			}
		end
	end
	self:delete()
end

entclass('SmallBreakBlock', TakesDamage)
SmallBreakBlock.animGroup = 'breakblock.png'
SmallBreakBlock.bbox = box2:new(.1)
SmallBreakBlock.scale = {.5,.5}
SmallBreakBlock.massInv = 1/3
function SmallBreakBlock:ctor(args)
	SmallBreakBlock.super.ctor(self, args)
	self:setVel(args.vel)
	self:setVelY(self:getVelY() - 5 - math.random() * 10)
	self:setRotation(math.random() * 360)
	self:setIgnoreEnts(true)
	self.startTime = getTime()
	self.lifespan = 10 + math.random() * 5
end
function SmallBreakBlock:think()
	SmallBreakBlock.super.think(self)
	if math.abs(self:getVelX()) < .1 and math.abs(self:getVelY()) < .1 then
		self:setRotation(0)
	end
	local frac = 1 - (getTime() - self.startTime) / self.lifespan
	frac = math.min(1, frac * 10)
	self:setColorW(frac)	-- ehh less to communicate if you recalc this clientside...
	if frac < 0 then self:delete() end
end

