require 'base.scripts.hud'
require 'wellstory.scripts.items'	--backpack

function drawHUD(info)

	local camera = viewGetBox()
	
	local hudDepth = -2

	-- show our goods
	-- health meter
	local frac = info.health / info.maxHealth
	local hudPos = vec2:new(32, 24):divTo(screenSize)	-- i hid screenSize in text.lua to prevent circular dependencies
	local hudSize = vec2:new(64, 10):divTo(screenSize)	-- work around? make a gui.lua?
	local hudUnitBox = box2:new(hudPos, hudPos + hudSize)
	local hudBox = box2:new(hudUnitBox):map(camera)
	drawRect{
		box=box2:new(hudUnitBox):map(camera);
		color=vec4:new(.5,0,0,1);
		depth=hudDepth;
		postFBO=true;
	}
	
	local eps = vec2:new(2):divTo(screenSize)
	hudBox = box2:new(hudPos + eps, vec2:new(hudPos[1] + hudSize[1] * frac, hudPos[2] + hudSize[2]) - eps):map(camera)
	drawRect{
		box=hudBox;
		color=vec4:new(1,0,0,1);
		depth=hudDepth;
		postFBO=true;
	}

	-- found in text.lua
	drawScreenText(100, 24, 16, 16, '' .. info.health .. '/' .. info.maxHealth)

	-- light scabbard anyone?
	if backpack.lightScabbard then
		drawSprite(
			vec2:new(234,36):divTo(screenSize):map(camera),	--pos
			0,	--angle
			{1,1},	--scale
			{1,1,1,1},	--color
			0,	--shader
			BLEND.NONE,	--blend
			true,	--postFBO?
			false,	--lighting
			false,	--left
			'light scabbard',	--group
			'idle',	--seq
			0,	--frame
			hudDepth)	--depth
	end

	if info.screenFlash[4] then
		screenFlash(info.screenFlash)
	end
end