require 'wellstory.scripts.text'	--ShowsDamage resides

animLoad('leech', 'leech/leech stand.png')

entclass('Leech', ShowsDamage)
Leech.animGroup = 'leech'
Leech.bbox = box2:new(.45)

Leech.maxHealth = 2		-- TakesDamage

Leech.turnTime = 5
Leech.speed = 2

function Leech:ctor(so)	
	Leech.super.ctor(self,so)
	-- how do we make something touchable but not collidable?
	self:setUseGravity(false)
	self:setFriction(0)
	self.startTime = getTime()
end
	
function Leech:touch(other)
	Leech.super.touch(self,other)
	if not self:isActive() then return end
	if other
	and other:isa(Player)
	and other.health > 0 
	then
		other:takeDamage(self,1)
	end
end

function Leech:think()
	Leech.super.think(self)
	if not self:isActive() then return end
	self:setUseGravity(mapGetType(self:getPosX(), self:getPosY()) ~= MAPTYPE.Liquid)
	Leech.super.think(self)
	if self.health < 0 then return end
	self:setVelX(self.speed * math.cos( (getTime() - self.startTime) * 2 * math.pi / self.turnTime))
	self:setLeft(self:getVelX() < 0)
end

Spawnable(Leech)
